# -*- coding: utf-8 -*-

# This file is part of Pigeon Planner.

# Pigeon Planner is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Pigeon Planner is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with Pigeon Planner.  If not, see <http://www.gnu.org/licenses/>


import gtksourceview2


class ExtraBox(gtksourceview2.View):
    __gtype_name__ = "ExtraBox"

    def __init__(self):
        gtksourceview2.View.__init__(self)
        self._buffer = gtksourceview2.Buffer()
        self._buffer.connect("changed", self.on_buffer_changed)
        self._buffer.connect("insert-text", self.on_buffer_insert_text)
        self.set_buffer(self._buffer)
        self.set_show_line_numbers(True)
        self.set_show_right_margin(True)
        self.set_right_margin_position(35)
#        self.set_highlight_current_line(True)
        self.set_insert_spaces_instead_of_tabs(True)
        self.set_tab_width(4)

    def get_text(self):
        return self._buffer.get_text(*self._buffer.get_bounds())

    def set_text(self, text):
        self._buffer.set_text(text)

    def get_lines(self):
        text = self._buffer.get_text(*self._buffer.get_bounds())
        return text.split("\n")

    def set_lines(self, lines):
        text = "\n".join(lines)
        self._buffer.set_text(text)

    def on_buffer_changed(self, widget):
        if widget.get_line_count() > 6:
            print("too much changed")

            start = widget.get_iter_at_line(6)
            end = widget.get_end_iter()
            widget.delete(start, end)
            widget.backspace(widget.get_end_iter(), True, True)

    def on_buffer_insert_text(self, widget, location, text, length):
        return
        if widget.get_line_count() >= 6:
            print("too much insert")
            widget.backspace(widget.get_end_iter(), True, True)
